#include <vector>
#include <string>
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <queue>
#include <cstring>
#include <algorithm>
#include <cmath>

#include "const.h"
#include "global.cpp"
#include "moves.cpp"

#define INF 0x7fffffff

using namespace std;

int turnNum;




// TODO:
//      - problema com o run (dois espaços)
//      - controle de bonecos


int mround(double x){
  if (x<0){
    return -(int)(round(-x));
  }
  return (int)(round(x));
}



bool consegue_passar(int x,int y){
  if (height[x][y]>=6) return false;
  if (ground[x][y]==GROUND_CHILD || ground[x][y]==GROUND_TREE) return false;
  return true;
}
bool consegue_construir(int x,int y){
  if (height[x][y]>=6) return false;
  if (ground[x][y]==GROUND_CHILD || ground[x][y]==GROUND_TREE) return false;
  return true;
}

bool consegue_atacar(ii p1, ii p2, ii end, int h){

//  fprintf(stderr,"throu em: %d %d\n",p2.first,p2.second);
//  fprintf(stderr,"quero atacar: %d %d\n",end.first,end.second);

  int x1=p1.first;
  int x2=p2.first;
  int y1=p1.second;
  int y2=p2.second;

  int n = max((int)fabs(x2-x1),(int)fabs(y2-y1));
//  fprintf(stderr,"n: %d\n",n);
  for (int t=1; t<=n; t++){
    int xatual = x1+mround((t*(x2-x1))/n);
    int yatual = y1+mround((t*(y2-y1))/n);
    int hatual = h - mround((9*t)/n);

//    fprintf(stderr,"xa ya: %d %d  height: %d  hatual: %d\n",xatual,yatual,height[xatual][yatual],hatual);
    if (xatual==end.first && yatual==end.second) return true;
    if (height[xatual][yatual]>=hatual) return false;
    int g = ground[xatual][yatual];
    if (g==GROUND_TREE || g==GROUND_CHILD || g==GROUND_TAKEN)
      return false;
  }

  return true;
}


bool notdiagonal(int dx, int dy){
  return (dx==0 || dy==0);
}


bool run(int c, int x, int y){
//  fprintf(stderr,"run\n");

  int nx,ny;
  queue<ii> q;
  bool visited[SIZE][SIZE];
  ii   pai[SIZE][SIZE];


  Child &child = cList[c];
  if (child.x==x && child.y==y) return false;

  memset(visited,0,sizeof(visited));
  while (!q.empty()) q.pop();

  q.push(ii(child.x,child.y));
  pai[child.x][child.y] = ii(child.x,child.y);
  while (!q.empty()){
    ii u = q.front(); q.pop();
    for (int i=0; i<8; i++){
      nx = u.first+dx[i];
      ny = u.second+dy[i];
      if (nx>SIZE || nx<0 || ny>SIZE || ny<0) continue;
      if (!visited[nx][ny] && ((nx==x && ny==y) || consegue_passar(nx,ny))){
        visited[nx][ny] = true;
        pai[nx][ny] = u;
        q.push(ii(nx,ny));
        if (nx==x && ny==y) goto end;
      }
    }
  }
  end:
  if (!q.empty()){
    ii pos = ii(nx,ny);
    while (pai[pos.first][pos.second].first!=child.x ||
           pai[pos.first][pos.second].second!=child.y){
      pos = pai[pos.first][pos.second];
    }

    if (!consegue_passar(pos.first,pos.second)) return false;

    bool entrou = false;
    if (pos.first!=x || pos.second!=y){
      if (notdiagonal( pos.first-child.x, pos.second-child.y )){
        if (pos.first > child.x && // para direita
            consegue_passar(pos.first+1,pos.second)){
          ground[pos.first][pos.second] = GROUND_CHILD;
          pos.first++;
          entrou = true;
        }
        if (pos.first < child.x && // para esquerda
            consegue_passar(pos.first-1,pos.second)){
          ground[pos.first][pos.second] = GROUND_CHILD;
          pos.first--;
          entrou = true;
        }

        if (pos.second > child.y && // para cima
            consegue_passar(pos.first,pos.second+1)){
          ground[pos.first][pos.second] = GROUND_CHILD;
          pos.second++;
          entrou = true;
        }
        if (pos.second < child.y && // para baixo
            consegue_passar(pos.first,pos.second-1)){
          ground[pos.first][pos.second] = GROUND_CHILD;
          pos.second--;
          entrou = true;
        }
      }
    }


    if ((entrou && !child.standing) ||
        (!notdiagonal(pos.first-child.x,pos.second-child.y) && !child.standing))
      return stand(c);

    if (child.standing) printf("run %d %d\n",pos.first,pos.second);
    else                printf("crawl %d %d\n",pos.first,pos.second);

    if (child.standing){ if (DEBUG) fprintf(stderr,"child %d: run %d %d\n",c,pos.first,pos.second); }
    else                 if (DEBUG) fprintf(stderr,"child %d: crawl %d %d\n",c,pos.first,pos.second);

    ground[child.x][child.y] = GROUND_TAKEN;
    ground[pos.first][pos.second] = GROUND_CHILD;
    return true;
  } else
    return false;
}



bool isbuilder(int);

bool pega_neve(int c, int limit){
//  fprintf(stderr,"pega_neve\n");
  Child &child = cList[c];
  int x, y;

  int s = child.holding;
  if (s==HOLD_P3) return false;
  if (s==HOLD_P2 && limit==2) return false;
  if (s==HOLD_P1 && limit==1) return false;
  if ((s==HOLD_S1 || s==HOLD_S2 || s==HOLD_S3) && limit==1) return false;
  if ((s==HOLD_S1 || s==HOLD_S2 || s==HOLD_S3) && limit!=1){
    for (int l=0; l<8; l++)
      if (drop(c,child.x+dx[l],child.y+dy[l],1))
        return true;
    return false;
  }
  if (s==HOLD_M  || s==HOLD_L)  return false;

  x=child.x; y=child.y;
  for (int i=1; i<8; i++){
      int nx = x+dx[i];
      int ny = y+dy[i];
      if (ground[nx][ny]==GROUND_EMPTY && height[nx][ny]>0){
        if (child.standing) return crouch(c);
        height[nx][ny]--;
        pickup(c,nx,ny,POWDERED);
        return true;
      }
  }
  int i=0;
  int nx = x+dx[i];
  int ny = y+dy[i];
  if (ground[nx][ny]==GROUND_EMPTY && height[nx][ny]>0){
    if (child.standing) return crouch(c);
    height[nx][ny]--;
    pickup(c,nx,ny,POWDERED);
    return true;
  }

  int r = rand()%8;
  return run(c, x+dx[r], y+dy[r]);

  return false;
}



bool faz_boneco(int c){
//  fprintf(stderr,"faz_boneco\n");
  Child &child = cList[c];
  int x, y;
  int nx, ny;
  int t=GROUND_EMPTY;

  x=child.x; y=child.y;
  bool fazendo = false;
  for (int i=0; i<8; i++){
    nx = x+dx[i];
    ny = y+dy[i];

    int s=ground[nx][ny];
    if (s==GROUND_L){
      t = GROUND_L;
      fazendo = true;
      break;
    }
    if (s==GROUND_LM){
      t = GROUND_LM;
      fazendo = true;
      break;
    }
    if (s==GROUND_SMR){
      t = GROUND_SMR;
      return false;
    }
  }

  if (fazendo){
    if (t==GROUND_L){
      if (height[nx][ny]+3>9) return false;
      if (!pega_neve(c,2))
        if (!crush(c))
          return drop(c,nx,ny,2);
        else
         return true;
      else return true;
    }
    if (t==GROUND_LM){
      if (height[nx][ny]+1>9) return false;
      if (!pega_neve(c,1))
        if (!crush(c))
          return drop(c,nx,ny,1);
        else
          return true;
      else return true;
    }
    return false;
  }


  if (!fazendo){
    if (!pega_neve(c,3))
      if (!crush(c)){
        for (int i=0; i<8; i++){
          if (drop(c,x+dx[i],y+dy[i],3))
            return true;
        }
        return false;
      } else
        return true;
    else return true;
  }
  return false;
}

bool stole(int c){
  //fprintf(stderr,"stole\n");

  Child &child = cList[c];
  int x, y;
  int nx, ny;
  ii pos;
  int t=GROUND_EMPTY;

  x=child.x; y=child.y;
  bool red  = false;
  bool blue = false;
  for (int i=0; i<8; i++){
    nx = x+dx[i];
    ny = y+dy[i];

    int s=ground[nx][ny];
    if (s==GROUND_LM){
      t = GROUND_LM;
      pos = ii(nx,ny);
      break;
    }

    if (s==GROUND_SMB){
      t = GROUND_SMB;
      blue = true;
      pos = ii(nx,ny);
      break;
    }
    //if (s==GROUND_SMR){
    //  t = GROUND_SMR;
    //  red = true;
    //}
  }

  if (t==GROUND_LM){
    if (!pega_neve(c,1))
      if (!crush(c))
        if (drop(c,pos.first,pos.second,1))
          return true;
        else return false;
      else return true;
    else return true;
  }

  if (blue){
    if (child.standing) return crouch(c);
    if (!pickup(c,pos.first,pos.second,SMALL_SB)){
      bool foi = false;
      for (int i=0; i<8; i++)
        if (drop(c,x+dx[i],y+dy[i],3)){
          foi = true;
          break;
        }
      if (!foi) return false;
    }
    height[pos.first][pos.second]--;
    //printf("pickup %d %d\n",pos.first,pos.second);
    //if (DEBUG) fprintf(stderr,"child %d: pickup %d %d\n",c,pos.first,pos.second);
    return true;
  }

  return false;
}

/*
struct objective {
  char f;
  ii pos;
};


struct objective p[4][128];
int obj[]={0,0,0,0};
*/

bool isbuilder(int i){
  return (i==0 || i==3);// || i==1);
}


vector<ii> to_build;
ii current_pos[4];
char current[4];



inline int dist(ii v1, ii v2){
  return ((v1.first-v2.first)*(v1.first-v2.first) +
          (v1.second-v2.second)*(v1.second-v2.second));
}


bool already_build(ii pos){
  for (int k=1; k<=2; k++)
    for (int l=0; l<8; l++)
      if (ground[pos.first+dx[l]*k][pos.second+dy[l]*k]==GROUND_SMR)
        return true;
  return false;
}

ii get_better_to_build(ii current_pos){

  int s = to_build.size();
  if (s==0) return ii(-1,-1);

  for (int i=0; i<s; i++)
    if (already_build(to_build[i]))
      to_build.erase(to_build.begin()+i);

  s = to_build.size();
  if (s==0) return ii(-1,-1);

  int tmp;
  ii low;
  int ndx = 0;
  int lower = dist(current_pos,to_build[0]);
  low = to_build[0];
  for (int i=1; i<s; i++){
    tmp = dist(current_pos, to_build[i]);
    if (tmp < lower || (tmp==lower && to_build[i].second<low.second)){
      lower = tmp;
      low = to_build[i];
      ndx = i;
    }
  }

  ii ret = to_build[ndx];
  to_build.erase(to_build.begin()+ndx);
  return ret;
}


struct snowman {
  ii p;    // snowman position
  int d;   // smaller distance
  int c;   // child closest
};

bool snowman_cmp(struct snowman a, struct snowman b){
  return (a.d<b.d);
}


bool vale_a_pena_construir(int c){
  Child &child = cList[c];

  for (int l=0; l<8; l++){
    int t = ground[child.x+dx[l]][child.y+dy[l]];
    if (t==GROUND_LM || (t==GROUND_L && child.holding==HOLD_P2) ||
        child.holding==HOLD_L || child.holding==HOLD_M)
      return true;
  }

  return false;
}

void check_for_enemy_snow_man(){
  int men,d,k,c;
  ii pos;
  vector<struct snowman> v;
  struct snowman s;

  // for each blue snow man
  for (int i=0; i<31; i++)
  for (int j=0; j<31; j++){
    if ((ground[i][j]==GROUND_SMB) || //&& snowman[i][j]!=SNOW_STEALING) ||
        (snowman[i][j]==SNOW_HIDDEN)){
      // add to v, the kid with less space from this snowman
      men = INF;
      //for (k=0; isbuilder(k) && current[k]!=STEAL && k<4; k++){
      for (k=0; k<4; k++){
        if (!isbuilder(k)) continue;

        d = dist( ii(i,j), ii(cList[k].x,cList[k].y));
        if (d<men){
          pos = ii(i,j);
          men = d;
          c = k;
        }
      }
      if (men==INF) continue;
      s.p = pos; s.d = men; s.c = c;
      v.push_back(s);
    }
  }

  if (v.size()==0) return;

  sort(v.begin(),v.end(),snowman_cmp);
  //fprintf(stderr,"++++++++++++===+++++++++++++++++++++++++\n");
  //for (int i=0; i<v.size(); i++){
    //fprintf(stderr,"boneco em %d,%d : menor distancia crianca %d ... %d\n",
    //    v[i].p.first,v[i].p.second,v[i].c,v[i].d);
  //}
  //fprintf(stderr,"++++++++++++===+++++++++++++++++++++++++\n");
  //s = v[0];
  //k = s.c;
  for (int ndx=0; ndx<v.size(); ndx++){
    //while (ndx<v.size()){//for (k=0; isbuilder(k) && current[k]!=STOLE && k<4; k++){
    s = v[ndx];
    k = s.c;
    int i = s.p.first;
    int j = s.p.second;

    // TODO
    // se a distancia para este boneco é menor que a distancia
    // que ele precisa esta roubando, tem que trocar.
    if (current[k]==STEAL || vale_a_pena_construir(k)) continue;

    //if (current[k]==STEAL) to_build.push_back(current_pos[k]);
    if (current_pos[k].first!=-1) to_build.push_back(current_pos[k]);
    snowman[i][j] = SNOW_STEALING;


    // find the best place to run close to the snowman
    current_pos[k] = ii(i+1,j);
    men = INF;
    for (int l=0; l<8; l++){
      if (!consegue_passar(i+dx[l],j+dy[l])) continue;
      d = dist(ii(cList[k].x,cList[k].y), ii(i+dx[l],j+dy[l]));
      if (d<men){
        current_pos[k] = ii(i+dx[l],j+dy[l]);
        men = d;
      }
    }
    if (men==INF){
      current[k] = NOTHING;
      if (DEBUG) fprintf(stderr,"crianca %d nao tem como pegar o boneco %d,%d\n",k,i,j);
    } else {
      current[k] = STEAL;
      if (DEBUG) fprintf(stderr,"crianca %d quer pegar o boneco %d,%d\n",k,i,j);
    }
  }
}


int get_defender_builder(int i){
  if (i==1) return 0;
  if (i==2) return 3;
  if (i==0) return 1;
  if (i==3) return 2;
}

ii posicao_de_defesa(ii p){
  int i;
  int x = p.first;
  int y = p.second;

  if (y<=10 && x<=10) i=4; // A
  if (x<=20 && y<=10 && x>10) i=1; //B
  if (x>20 && y<=10) i=6; // C
  if (y<=20 && y>10 && x<=10) i=0; //D
  if (x>10 && x<=20 && y>10 && y<=20) i = rand()%8; //E
  if (x>20 && y>10 && y<=20) i=2; // F
  if (x<=10 && y>20) i=5; //G
  if (y>20 && x>10 && x<=20) i=3; // H
  if (x>20 && y>20) i=7; // I

  ii pos = ii(p.first+dx[i]*3, p.second+dy[i]*3);
  return pos;
}

bool atack(int c){

  bool conheco = false;
  //if (!cList[c].standing) return stand(c);


  if (badatack[c]>=4){
    badatack[c] = 0;
    return run(c,cList[badatack[c]].x, cList[badatack[c]].y);
  }

  for (int i=4; i<cList.size(); i++){
    if (cList[i].x==-1) continue;
    conheco = true;

    int dx = cList[i].x - cList[c].x;
    int dy = cList[i].y - cList[c].y;
    int d = dx * dx + dy * dy;

    if (d<10*10){
      if (cList[i].sendo_atacada ||
          !consegue_atacar(ii(cList[c].x,cList[c].y),
                           ii(cList[c].x+dx*2,cList[c].y+dy*2),
                           ii(cList[i].x,cList[i].y),
                           cList[c].standing?9:6)){
        //if (cList[i].sendo_atacada ||
        //    !consegue_atacar(ii(cList[c].x,cList[c].y),
        //                   ii(cList[c].x+dx*2,cList[c].y+dy*2),
         //                  ii(cList[i].x,cList[i].y),
         //                  !cList[c].standing?9:6)){
          continue;
        //} else {
        //  if (!cList[c].standing) return stand(c);
       // }
      }
          //cList[i].dazed) continue;

      cList[i].sendo_atacada=true;
      atacks.push_back(ii(c,i));
      return _throw(c,cList[c].x + dx*2,cList[c].y + dy*2);
      //printf("throw %d %d\n",cList[c].x + dx*2,cList[c].y + dy*2);
      //if (DEBUG) fprintf(stderr,"child %d: throw %d %d\n",c,cList[c].x+dx*2,cList[c].y+dy*2);
      //return true;
    }
  }

  // cant attack
/*  if (conheco){
    int men = INF;
    int ndx = -1;
    for (int i=4; i<cList.size(); i++){
      if (cList[i].x==-1) continue;
      int d = dist(ii(cList[i].x,cList[i].y), ii(cList[c].x,cList[c].y));
      if (d<men){
        men = d;
        ndx = i;
      }
    }
    return run(c,cList[ndx].x,cList[ndx].y);
  }*/

  int mybuilder = get_defender_builder(c);
  ii pos = posicao_de_defesa(current_pos[mybuilder]);
  return run(c, pos.first,pos.second);
}


bool defend_myself(int c){

  for (int i=4; i<cList.size(); i++){
    if (cList[i].x==-1) continue;

    int dx = cList[c].x - cList[i].x;
    int dy = cList[c].y - cList[i].y;
    int d = dx * dx + dy * dy;

    if (d<8*8){
      int s = cList[i].holding;
      bool t = cList[i].dazed;
      if (!t &&
          (s==HOLD_S1 || s==HOLD_S2 || s==HOLD_S3) &&
          consegue_atacar(ii(cList[i].x,cList[i].y),
                           ii(cList[i].x+dx*2,cList[i].y+dy*2),
                           ii(cList[c].x,cList[c].y),
                           cList[i].standing?9:6)){
        if (_catch(c,cList[i].x,cList[i].y))
          return true;
      }
      int s1 = cList[c].holding;
      if (s1==HOLD_S1 || s1==HOLD_S2 || s1==HOLD_S3){
        return atack(c);
      }
    }
  }

  return false;
}


// Try to pick a next move.  Return false if the child just
// turns in place and chooses no move.
bool chooseMove( int i ) {
  // Figure out where this child is about to move.
  Child &child = cList[ i ];
  /*struct objective o;
  o.f = FLAG_RUN;
  o.pos = ii(8,9);
  p[1][0] = o;
*/

  // If we're dazed, we have to stay idle.
  if ( child.dazed > 0 ) {
    badatack[i] = 0;
    countdazed[i]++;
    printf("idle\n");
    if (DEBUG) fprintf(stderr,"child %d: idle\n",i);
    return true;
  }
  countdazed[i]=0;

  if (isbuilder(i)){
    // builders

    //int mybuilder = get_defender_builder(i);
    //if (countdazed[mybuilder]>4) goto defender;

    if (defend_myself(i)) return true;

    if (current[i]==NOTHING){
      current_pos[i] = get_better_to_build(ii(child.x,child.y));
      if (current_pos[i].first==-1){
        goto defender;
        printf("idle\n");
        if (DEBUG) fprintf(stderr,"child %d: idle\n",i);
        return true;
      }
      fprintf(stderr,"crianca %d vai construir em %d %d\n",i,current_pos[i].first,current_pos[i].second);
      current[i] = BUILD;
    }

    if (!run(i,current_pos[i].first,current_pos[i].second))
      if (current[i]==BUILD && (!faz_boneco(i) || already_build(current_pos[i]))){
          current[i] = NOTHING;
          return chooseMove(i);
      } else if (current[i]==STEAL && !stole(i)){
          current[i] = NOTHING;
          return chooseMove(i);
      }

  } else {
    // defenders
    defender:
    if (!pega_neve(i,1)){
      if (!crush(i)){
        if (!atack(i)){
          printf("idle\n");
          if (DEBUG) fprintf(stderr,"child %d: idle\n",i);
        }
      }
    }
  }


  return true;
}

int main() {

  to_build.push_back(ii(4,6));
  to_build.push_back(ii(4,16));
  to_build.push_back(ii(4,26));

  to_build.push_back(ii(15,6));
  to_build.push_back(ii(15,16));
  to_build.push_back(ii(15,26));

  to_build.push_back(ii(25,6));
  to_build.push_back(ii(25,16));
  to_build.push_back(ii(25,26));


  current[0] = current[1] = current[2] = current[3] = NOTHING;

  for (int i=0; i<8; i++){
    badatack[i] = 0;
    countdazed[i]=0;
  }

  // we start knowing nothing about the field
  memset(snowman,SNOW_UNKNOWN,sizeof(snowman));

  cin >> turnNum;
  while (turnNum>=0){

    if (DEBUG) fprintf(stderr,"turno: %d\n",turnNum);

    // Read the current_pos score.
    cin >> score[ RED ] >> score[ BLUE ];

    // Read the state of the field.
    for (int i=0; i<SIZE; i++)
      for (int j=0; j<SIZE; j++){
        char a, b;
        cin >> a >> b;
        if ( a != '*' ){
          height[ i ][ j ] = a - '0';
          ground[ i ][ j ] = b - 'a';
          if (ground[i][j]==GROUND_SMR || ground[i][j]==GROUND_SMB){
            int sm = snowman[i][j];
            if (sm==SNOW_UNKNOWN || sm==SNOW_EMPTY || sm==SNOW_BLUE || sm==SNOW_RED)
              snowman[i][j] = ground[i][j];
            if (ground[i][j]==GROUND_SMR)
              snowman[i][j] = SNOW_RED;
          }
          if (ground[i][j]==GROUND_LM && snowman[i][j]==SNOW_RED)
            snowman[i][j] = SNOW_HIDDEN;
          else if (ground[i][j]==GROUND_L || (ground[i][j]==GROUND_LM && snowman[i][j]!=SNOW_HIDDEN)){
            snowman[i][j] = SNOW_BUILDING;
          }
        } else {
          height[ i ][ j ] = -1;
          ground[ i ][ j ] = -1;
          if (snowman[i][j]==SNOW_BUILDING || snowman[i][j]==SNOW_RED){
            snowman[i][j] = SNOW_HIDDEN;
            fprintf(stderr,"ACHO QUE TEM UM BONECO AZUL EM: %d,%d\n",i,j);
          }
        }
      }

    string token;
    for ( int i = 0; i < cList.size(); i++ ) {
      cin >> token;
      if ( token == "*" ) {
        // Can't see this child
        cList[ i ].x = -1;
        cList[ i ].y = -1;
      } else {
        // Can see this child, read the description.
        cList[ i ].x = atoi( token.c_str() );
        cin >> cList[ i ].y;

        // Fill in the child's side.
        cList[ i ].color = i / CCOUNT;

        // Read the child's stanse, what he's holding and how much
        // longer he's dazed.
        char ch;
        cin >> ch;
        cList[ i ].standing = ( ch == 'S' );
        cin >> ch;
        cList[ i ].holding = ( ch - 'a' );
        cin >> cList[ i ].dazed;

        cList[i].sendo_atacada=false;
      }
    }

    // Mark child locations, so we can walk around them.
    for ( int i = 0; i < cList.size(); i++ ) {
      if ( cList[ i ].x >= 0 ) {
        ground[ cList[ i ].x ][ cList[ i ].y ] = GROUND_CHILD;
      }
    }

    for (int i=0; i<atacks.size(); i++)
      if (!cList[atacks[i].second].dazed)
        badatack[atacks[i].first] = atacks[i].second;
    atacks.clear();

    check_for_enemy_snow_man();

    // Choose an action for each child.
    for ( int i = 0; i < CCOUNT; i++ ) {
      //while ( tryCount < 3 && !chooseMove( i ) )
      chooseMove(i);
    }
    if (DEBUG) fprintf(stderr,"================\n");

    cin >> turnNum;
  }
}
