#include <cstdio>
#include "const.h"

// crouch action
bool crouch(int c){
  //fprintf(stderr,"crouch\n");
  Child &child = cList[c];
  int s = child.standing;
  if (!s) return false;

  printf("crouch\n");
  child.standing = false;
  if (DEBUG) fprintf(stderr,"child %d: crouch\n",c);
  return true;
}

// stand action
bool stand(int c){
  //fprintf(stderr,"stand\n");
  Child &child = cList[c];
  int s = child.standing;
  if (s) return false;

  printf("stand\n");
  child.standing = true;
  if (DEBUG) fprintf(stderr,"child %d: stand\n",c);
  return true;
}

bool crush(int c){
  Child &child = cList[c];
  int s = child.holding;
  if (s==HOLD_S1 || s==HOLD_S2 || s==HOLD_S3 ||
      s==HOLD_M || s==HOLD_L || s==HOLD_EMPTY) return false;
  printf("crush\n");
  if (DEBUG) fprintf(stderr,"child %d: crush\n",c);
  return true;
}
bool drop(int c,int x,int y, int size){
  if (ground[x][y]==GROUND_CHILD || ground[x][y]==GROUND_TREE ||
      ground[x][y]==GROUND_TAKEN) return false;

  if (height[x][y]+size>9) return false;
  if (size==3 && height[x][y]+6>9) return false;

  if (size==1 && ground[x][y]==GROUND_L) return false;
  if (size==2 && ground[x][y]==GROUND_LM) return false;

  printf("drop %d %d\n",x,y);
  if (DEBUG) fprintf(stderr,"child %d: drop %d %d\n",c,x,y);

  ground[x][y] = GROUND_TAKEN;
  return true;
}
bool pickup(int c,int x,int y,char type){
  //fprintf(stderr,"pickup\n");
  if (ground[x][y]==GROUND_CHILD || ground[x][y]==GROUND_TREE ||
      ground[x][y]==GROUND_TAKEN) return false;

  Child &child = cList[c];
  int s = child.holding;
  if (s==HOLD_S3 || s==HOLD_M || s==HOLD_L) return false;
  if (type==SMALL_SB &&
        (s==HOLD_S3 || s==HOLD_M  || s==HOLD_L ||
         s==HOLD_P3 || s==HOLD_P2)) return false;
  if (type==SMALL_SB && s==HOLD_P1) return crush(c);

  printf("pickup %d %d\n",x,y);
  if (DEBUG) fprintf(stderr,"child %d: pickup %d %d\n",c,x,y);

  ground[x][y] = GROUND_TAKEN;
  return true;
}

bool _throw(int c, int x, int y){
  Child &child = cList[c];
  int s = child.holding;
  if (s==HOLD_P1) return crush(c);
  if (s==HOLD_P2 || s==HOLD_P3 || s==HOLD_M || s==HOLD_L){
    bool foi = false;
    for (int i=0; i<8; i++)
      if (drop(c,x+dx[i],y+dy[i],2)){
        foi = true;
        break;
      }
    if (!foi) return false;
  }

  if (s!=HOLD_S1 && s!=HOLD_S2 && s!=HOLD_S3) return false;

  printf("throw %d %d\n",x,y);
  if (DEBUG) fprintf(stderr,"child %d: throw %d %d\n",c,x,y);
}
// crouch action
bool _catch(int c,int x,int y){
  //fprintf(stderr,"crouch\n");
  Child &child = cList[c];
  int s = child.holding;

  if (s==HOLD_S3 || s==HOLD_M || s==HOLD_L) return false;
  if (s==HOLD_P1) return crush(c);

  printf("catch %d %d\n",x,y);
  if (DEBUG) fprintf(stderr,"crianca %d: catch %d %d\n",c,x,y);
  return true;
}

